From 813daae97602ad7143e23fd6d955bef5e413dc7a Mon Sep 17 00:00:00 2001
From: hackademix <giorgio@maone.net>
Date: Sep 18 2018 15:15:30 +0000
Subject: Update for compatibility with Acorn 6.


---

diff --git a/.gitignore b/.gitignore
index 7258bbe..9a139c8 100644
--- a/.gitignore
+++ b/.gitignore
@@ -10,5 +10,6 @@ node_modules/
 # artifacts
 librejs.xpi
 bundle.js
+test_bundle.js
 npm-debug.log
 package-lock.json
diff --git a/README b/README
index 73cc7dc..a380900 100644
--- a/README
+++ b/README
@@ -4,7 +4,7 @@
 BUILD:
 
 First, you need to get some stuff with npm:
-  $ npm install acorn
+  $ npm install acorn-loose
   $ npm install jssha
   $ npm install browserify
   $ export PATH=$PATH:./node_modules/.bin
diff --git a/build.sh b/build.sh
index 264eb00..1e07fcb 100755
--- a/build.sh
+++ b/build.sh
@@ -14,7 +14,6 @@ cp -r ./html ./build_temp
 cp -r ./content ./build_temp
 cp -r ./common ./build_temp
 cp manifest.json ./build_temp
-cp contact_finder.js ./build_temp
 cp bundle.js ./build_temp
 
 # build zip file from temp directory
diff --git a/evaluation test/test.js b/evaluation test/test.js
index 4e10d8a..091c47c 100644
--- a/evaluation test/test.js
+++ b/evaluation test/test.js
@@ -1,6 +1,5 @@
-var acorn = require('acorn/dist/acorn_loose');
-var walk = require("acorn/dist/walk");
-var acorn_base = require("acorn");
+var acornLoose = require('acorn-loose');
+var acorn = require("acorn");
 
 var fname_data = {
 	"WebGLShader": true,
@@ -851,12 +850,12 @@ function dbg_print(a,b){
 	}
 }
 function full_evaluate(script){
-		var res = true;		
+		var res = true;
 		if(script === undefined || script == ""){
-			return [true,"Harmless null script"];		
+			return [true,"Harmless null script"];
 		}
 
-		var ast = acorn.parse_dammit(script).body[0];
+		var ast = acornLoose.parse(script).body[0];
 
 		var flag = false;
 		var amtloops = 0;
@@ -864,10 +863,10 @@ function full_evaluate(script){
 		var loopkeys = {"for":true,"if":true,"while":true,"switch":true};
 		var operators = {"||":true,"&&":true,"=":true,"==":true,"++":true,"--":true,"+=":true,"-=":true,"*":true};
 		try{
-			var tokens = acorn_base.tokenizer(script);	
+			var tokens = acorn.tokenizer(script);
 		}catch(e){
 			console.warn("Tokenizer could not be initiated (probably invalid code)");
-			return [false,"Tokenizer could not be initiated (probably invalid code)"];		
+			return [false,"Tokenizer could not be initiated (probably invalid code)"];
 		}
 		try{
 			var toke = tokens.getToken();
@@ -911,66 +910,66 @@ function full_evaluate(script){
 			}
 		}
 		var error_count = 0;
-		while(toke.type != acorn_base.tokTypes.eof){
+		while(toke.type != acorn.tokTypes.eof){
 			if(toke.type.keyword !== undefined){
 				// This type of loop detection ignores functional loop alternatives and ternary operators
 				//dbg_print("Keyword:"+toke.type.keyword);
 				console.log(toke);
 				if(toke.type.keyword == "function"){
 					dbg_print("%c NONTRIVIAL: Function declaration.","color:red");
-					if(DEBUG == false){			
+					if(DEBUG == false){
 						return [false,"NONTRIVIAL: Function declaration."];
-					}		
+					}
 				}
 
 				if(loopkeys[toke.type.keyword] !== undefined){
 					amtloops++;
 					if(amtloops > 3){
 						dbg_print("%c NONTRIVIAL: Too many loops/conditionals.","color:red");
-						if(DEBUG == false){			
+						if(DEBUG == false){
 							return [false,"NONTRIVIAL: Too many loops/conditionals."];
-						}		
+						}
 					}
 				}
 			}else if(toke.value !== undefined){
 				var status = fname_data[toke.value];
-				if(status === true){ // is the identifier banned?				
+				if(status === true){ // is the identifier banned?
 					dbg_print("%c NONTRIVIAL: nontrivial token: '"+toke.value+"'","color:red");
-					if(DEBUG == false){			
+					if(DEBUG == false){
 						return [false,"NONTRIVIAL: nontrivial token: '"+toke.value+"'"];
-					}	
+					}
 				}else if(status === false){// is the identifier not banned?
 					// Is there bracket suffix notation?
-					if(operators[toke.value] === undefined){					
+					if(operators[toke.value] === undefined){
 						if(is_bsn(toke.end)){
 							dbg_print("%c NONTRIVIAL: Bracket suffix notation on variable '"+toke.value+"'","color:red");
-							if(DEBUG == false){			
+							if(DEBUG == false){
 								return [false,"%c NONTRIVIAL: Bracket suffix notation on variable '"+toke.value+"'"];
-							}	
+							}
 						}
 					}
 				}else if(status === undefined){// is the identifier user defined?
 					// Are arguments being passed to a user defined variable?
 					if(being_called(toke.end)){
 						dbg_print("%c NONTRIVIAL: User defined variable '"+toke.value+"' called as function","color:red");
-						if(DEBUG == false){			
+						if(DEBUG == false){
 							return [false,"NONTRIVIAL: User defined variable '"+toke.value+"' called as function"];
-						}	
+						}
 					}
 					// Is there bracket suffix notation?
-					if(operators[toke.value] === undefined){					
+					if(operators[toke.value] === undefined){
 						if(is_bsn(toke.end)){
 							dbg_print("%c NONTRIVIAL: Bracket suffix notation on variable '"+toke.value+"'","color:red");
-							if(DEBUG == false){			
+							if(DEBUG == false){
 								return [false,"NONTRIVIAL: Bracket suffix notation on variable '"+toke.value+"'"];
-							}	
+							}
 						}
 					}
 				}else{
 					dbg_print("trivial token:"+toke.value);
 				}
 			}
-			// If not a keyword or an identifier it's some kind of operator, field parenthesis, brackets 
+			// If not a keyword or an identifier it's some kind of operator, field parenthesis, brackets
 			try{
 				toke = tokens.getToken();
 			}catch(e){
@@ -990,9 +989,8 @@ function full_evaluate(script){
 window.onload = function () {
 	document.getElementById("parse").addEventListener("click",function(){
 		var script = document.getElementById("input").value;
-		var ast = acorn.parse_dammit(script).body[0];
+		var ast = acornLoose.parse(script).body[0];
 		document.getElementById("output").innerHTML = JSON.stringify(ast, null, '\t'); // Indented with tab
 		document.getElementById("output").innerHTML = full_evaluate(script) + "\n\n" + document.getElementById("output").innerHTML;
 	});
 }
-
diff --git a/main_background.js b/main_background.js
index 9e08976..5b745c1 100644
--- a/main_background.js
+++ b/main_background.js
@@ -20,10 +20,9 @@
 * along with GNU LibreJS.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-var acorn_base = require("acorn");
-var acorn = require('acorn/dist/acorn_loose');
+var acorn = require('acorn');
+var acornLoose = require('acorn-loose');
 var jssha = require('jssha');
-var walk = require("acorn/dist/walk");
 var legacy_license_lib = require("./legacy_license_check.js");
 var {ResponseProcessor} = require("./bg/ResponseProcessor");
 var {Storage, ListStore} = require("./common/Storage");
@@ -462,7 +461,7 @@ function full_evaluate(script){
 			return [true,"Harmless null script"];
 		}
 
-		var ast = acorn.parse_dammit(script).body[0];
+		var ast = acornLoose.parse(script).body[0];
 
 		var flag = false;
 		var amtloops = 0;
@@ -470,7 +469,7 @@ function full_evaluate(script){
 		var loopkeys = {"for":true,"if":true,"while":true,"switch":true};
 		var operators = {"||":true,"&&":true,"=":true,"==":true,"++":true,"--":true,"+=":true,"-=":true,"*":true};
 		try{
-			var tokens = acorn_base.tokenizer(script);
+			var tokens = acorn.tokenizer(script);
 		}catch(e){
 			console.warn("Tokenizer could not be initiated (probably invalid code)");
 			return [false,"Tokenizer could not be initiated (probably invalid code)"];
@@ -512,7 +511,7 @@ function full_evaluate(script){
 			return script.charAt(end+i) == "[";
 		}
 		var error_count = 0;
-		while(toke !== undefined && toke.type != acorn_base.tokTypes.eof){
+		while(toke !== undefined && toke.type != acorn.tokTypes.eof){
 			if(toke.type.keyword !== undefined){
 				//dbg_print("Keyword:");
 				//dbg_print(toke);

